package cn.ibizlab.r7.runtime.service.runtimemgr.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.core.r7rt_base.valuerule.anno.application.*;
import cn.ibizlab.r7.runtime.core.r7rt_base.domain.Application;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[ApplicationDTO]
 */
public class ApplicationDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @ApplicationUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @ApplicationUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [APPLICATIONNAME]
     *
     */
    @ApplicationApplicationNameDefault(info = "默认规则")
    private String applicationName;

    @JsonIgnore
    private boolean applicationNameDirtyFlag;

    /**
     * 属性 [ENABLE]
     *
     */
    @ApplicationEnableDefault(info = "默认规则")
    private Integer enable;

    @JsonIgnore
    private boolean enableDirtyFlag;

    /**
     * 属性 [APPLICATIONID]
     *
     */
    @ApplicationApplicationIdDefault(info = "默认规则")
    private String applicationId;

    @JsonIgnore
    private boolean applicationIdDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @ApplicationCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @ApplicationCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [SYSTEMID]
     *
     */
    @ApplicationSystemIdDefault(info = "默认规则")
    private String systemId;

    @JsonIgnore
    private boolean systemIdDirtyFlag;


    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [APPLICATIONNAME]
     */
    @JsonProperty("applicationname")
    public String getApplicationName(){
        return applicationName ;
    }

    /**
     * 设置 [APPLICATIONNAME]
     */
    @JsonProperty("applicationname")
    public void setApplicationName(String  applicationName){
        this.applicationName = applicationName ;
        this.applicationNameDirtyFlag = true ;
    }

    /**
     * 获取 [APPLICATIONNAME]脏标记
     */
    @JsonIgnore
    public boolean getApplicationNameDirtyFlag(){
        return applicationNameDirtyFlag ;
    }

    /**
     * 获取 [ENABLE]
     */
    @JsonProperty("enable")
    public Integer getEnable(){
        return enable ;
    }

    /**
     * 设置 [ENABLE]
     */
    @JsonProperty("enable")
    public void setEnable(Integer  enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [ENABLE]脏标记
     */
    @JsonIgnore
    public boolean getEnableDirtyFlag(){
        return enableDirtyFlag ;
    }

    /**
     * 获取 [APPLICATIONID]
     */
    @JsonProperty("applicationid")
    public String getApplicationId(){
        return applicationId ;
    }

    /**
     * 设置 [APPLICATIONID]
     */
    @JsonProperty("applicationid")
    public void setApplicationId(String  applicationId){
        this.applicationId = applicationId ;
        this.applicationIdDirtyFlag = true ;
    }

    /**
     * 获取 [APPLICATIONID]脏标记
     */
    @JsonIgnore
    public boolean getApplicationIdDirtyFlag(){
        return applicationIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [SYSTEMID]
     */
    @JsonProperty("systemid")
    public String getSystemId(){
        return systemId ;
    }

    /**
     * 设置 [SYSTEMID]
     */
    @JsonProperty("systemid")
    public void setSystemId(String  systemId){
        this.systemId = systemId ;
        this.systemIdDirtyFlag = true ;
    }

    /**
     * 获取 [SYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getSystemIdDirtyFlag(){
        return systemIdDirtyFlag ;
    }



    public Application toDO() {
        Application srfdomain = new Application();
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getApplicationNameDirtyFlag())
            srfdomain.setApplicationName(applicationName);
        if(getEnableDirtyFlag())
            srfdomain.setEnable(enable);
        if(getApplicationIdDirtyFlag())
            srfdomain.setApplicationId(applicationId);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getSystemIdDirtyFlag())
            srfdomain.setSystemId(systemId);

        return srfdomain;
    }

    public void fromDO(Application srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getApplicationNameDirtyFlag())
            this.setApplicationName(srfdomain.getApplicationName());
        if(srfdomain.getEnableDirtyFlag())
            this.setEnable(srfdomain.getEnable());
        if(srfdomain.getApplicationIdDirtyFlag())
            this.setApplicationId(srfdomain.getApplicationId());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getSystemIdDirtyFlag())
            this.setSystemId(srfdomain.getSystemId());

    }

    public List<ApplicationDTO> fromDOPage(List<Application> poPage)   {
        if(poPage == null)
            return null;
        List<ApplicationDTO> dtos=new ArrayList<ApplicationDTO>();
        for(Application domain : poPage) {
            ApplicationDTO dto = new ApplicationDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

